<!DOCTYPE html>
<head>
    <title>Определение адреса клика на карте с помощью обратного геокодирования</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <script src="https://api-maps.yandex.ru/2.1/?lang=ru_RU&amp;apikey=c9b0e177-1670-46c3-93a4-35298f27859a" type="text/javascript"></script>
    <script>
        ymaps.ready(init);

        function init() {
            let myPlacemark,
                myMap = new ymaps.Map('map', {
                    center: [58.60, 49.64],
                    zoom: 14,
                    controls: []
                }, {
                    searchControlProvider: 'yandex#search',
                    yandexMapDisablePoiInteractivity: true,
                    suppressMapOpenBlock: true
                });

            // Слушаем клик на карте.
            myMap.events.add('click', function (e) {
                var coords = e.get('coords');
                // Создание независимого экземпляра балуна и отображение его в центре карты.

                // Если метка уже создана – просто передвигаем ее.
                if (myPlacemark) {
                    myPlacemark.geometry.setCoordinates(coords);
                }
                // Если нет – создаем.
                else {
                    myPlacemark = createPlacemark(coords);
                    myMap.geoObjects.add(myPlacemark);
                    // Слушаем событие окончания перетаскивания на метке.
                    myPlacemark.events.add('dragend', function () {
                        getAddress(myPlacemark.geometry.getCoordinates());
                    });
                }
                getAddress(coords);
            });

            // Создание метки.
            function createPlacemark(coords) {
                return new ymaps.Placemark(coords, {
                    iconCaption: 'поиск...'
                }, {
                    preset: 'islands#violetDotIconWithCaption',
                    draggable: true
                });
            }

            // Определяем адрес по координатам (обратное геокодирование).
            function getAddress(coords) {
                myPlacemark.properties.set('iconCaption', 'поиск...');
                ymaps.geocode(coords).then(function (res) {
                    let firstGeoObject = res.geoObjects.get(0);
                    let address = firstGeoObject.getThoroughfare() === undefined
                        ? "Некорректный адрес"
                        : (firstGeoObject.getPremiseNumber() === undefined
                            ? "Некорректный адрес"
                            : firstGeoObject.getThoroughfare() + ", " + firstGeoObject.getPremiseNumber());

                    myPlacemark.properties
                        .set({
                            // Формируем строку с данными об объекте.
                            iconCaption: [
                                address
                            ],
                            // В качестве контента балуна задаем строку с адресом объекта.
                            balloonContent: address
                        });
                    myPlacemark.balloon.open([51.85, 38.37], "Содержимое балуна", {
                        // Опция: не показываем кнопку закрытия.
                        closeButton: false,
                        panelMaxMapArea: Infinity
                    });
                });
            }
        }

    </script>
    <style type="text/css">
        html, body {
            width: 100%;
            height: 100%;
            margin: 0;
            padding: 0;
            font-family: Arial;
            font-size: 14px;
        }
        #map {
            width: 100%;
            height: 100%;
        }
    </style>
</head>
<body>
<div id="map"></div>
</body>
</html>
